"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createPersistStore = void 0;
var utils_1 = require("./utils");
function createPersistStore(_a) {
    var _this = this;
    var key = _a.key, initialData = _a.initialData, storage = _a.storage, transform = _a.transform;
    var listeners = new Set();
    var serialize = function (value) {
        return typeof value === "string" ? value : JSON.stringify(value);
    };
    var getInitialData = function () {
        if ((0, utils_1.isFunction)(initialData)) {
            return initialData();
        }
        return initialData;
    };
    return {
        get: function () { return __awaiter(_this, void 0, void 0, function () {
            var value;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, storage.getItem(key)];
                    case 1:
                        value = _a.sent();
                        if (value == null) {
                            return [2 /*return*/, getInitialData()];
                        }
                        if (transform !== undefined) {
                            return [2 /*return*/, transform(value)];
                        }
                        return [2 /*return*/, value];
                }
            });
        }); },
        set: function (value) { return __awaiter(_this, void 0, void 0, function () {
            var data;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        data = serialize(value);
                        return [4 /*yield*/, storage.setItem(key, data)];
                    case 1:
                        _a.sent();
                        listeners.forEach(function (listener) {
                            listener(value);
                        });
                        return [2 /*return*/];
                }
            });
        }); },
        remove: function () { return __awaiter(_this, void 0, void 0, function () {
            var initialData;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, storage.removeItem(key)];
                    case 1:
                        _a.sent();
                        initialData = getInitialData();
                        listeners.forEach(function (listener) {
                            listener(initialData);
                        });
                        return [2 /*return*/];
                }
            });
        }); },
        key: key,
        __setWithoutDispatch: function (value) { return __awaiter(_this, void 0, void 0, function () {
            var data;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        data = serialize(value);
                        return [4 /*yield*/, storage.setItem(key, data)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        }); },
        __subscribe: function (callback) {
            listeners.add(callback);
        },
        __unsubscribe: function (callback) {
            if (listeners.has(callback)) {
                listeners.delete(callback);
            }
        },
    };
}
exports.createPersistStore = createPersistStore;
