"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var react_hooks_1 = require("@testing-library/react-hooks");
var _1 = require(".");
var createPersistStore_1 = require("./createPersistStore");
var PersistStateProvider_1 = require("./PersistStateProvider");
var async_storage_1 = __importDefault(require("@react-native-async-storage/async-storage"));
describe("uesPersistState", function () {
    it("should be suspended on the first render if no cache found", function () { return __awaiter(void 0, void 0, void 0, function () {
        var store, client, _a, result, waitForNextUpdate;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    store = (0, createPersistStore_1.createPersistStore)({
                        key: "foo",
                        initialData: 100,
                        storage: async_storage_1.default,
                    });
                    client = new PersistStateProvider_1.PersistStateClient();
                    _a = (0, react_hooks_1.renderHook)(function () { return (0, _1.usePersistState)(store); }, {
                        wrapper: function (_a) {
                            var children = _a.children;
                            return (react_1.default.createElement(PersistStateProvider_1.PersistStateProvider, { client: client }, children));
                        },
                    }), result = _a.result, waitForNextUpdate = _a.waitForNextUpdate;
                    return [4 /*yield*/, waitForNextUpdate()];
                case 1:
                    _b.sent();
                    expect(result.current[0]).toEqual(100);
                    return [2 /*return*/];
            }
        });
    }); });
    it("should not be suspended on the first render if no cache found", function () { return __awaiter(void 0, void 0, void 0, function () {
        var store, client, value, result;
        return __generator(this, function (_a) {
            store = (0, createPersistStore_1.createPersistStore)({
                key: "foo",
                initialData: 100,
                storage: async_storage_1.default,
            });
            client = new PersistStateProvider_1.PersistStateClient();
            value = 12345;
            client.cacheMap.set(store.key, value);
            client.fulfilledFlagMap.set(store.key, true);
            result = (0, react_hooks_1.renderHook)(function () { return (0, _1.usePersistState)(store); }, {
                wrapper: function (_a) {
                    var children = _a.children;
                    return (react_1.default.createElement(PersistStateProvider_1.PersistStateProvider, { client: client }, children));
                },
            }).result;
            expect(result.current[0]).toEqual(value);
            return [2 /*return*/];
        });
    }); });
    it("state should be updated when store value is updated", function () { return __awaiter(void 0, void 0, void 0, function () {
        var store, client, _a, result, waitForNextUpdate;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    store = (0, createPersistStore_1.createPersistStore)({
                        key: "foo",
                        initialData: 100,
                        storage: async_storage_1.default,
                    });
                    client = new PersistStateProvider_1.PersistStateClient();
                    _a = (0, react_hooks_1.renderHook)(function () { return (0, _1.usePersistState)(store); }, {
                        wrapper: function (_a) {
                            var children = _a.children;
                            return (react_1.default.createElement(PersistStateProvider_1.PersistStateProvider, { client: client }, children));
                        },
                    }), result = _a.result, waitForNextUpdate = _a.waitForNextUpdate;
                    return [4 /*yield*/, waitForNextUpdate()];
                case 1:
                    _b.sent();
                    store.set(12345);
                    return [4 /*yield*/, waitForNextUpdate()];
                case 2:
                    _b.sent();
                    expect(result.current[0]).toEqual(12345);
                    return [2 /*return*/];
            }
        });
    }); });
    it("should dispatch the value to the store when setState is called", function () { return __awaiter(void 0, void 0, void 0, function () {
        var store, client, _a, result, waitForNextUpdate, subscriber;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    store = (0, createPersistStore_1.createPersistStore)({
                        key: "foo",
                        initialData: 100,
                        storage: async_storage_1.default,
                    });
                    client = new PersistStateProvider_1.PersistStateClient();
                    _a = (0, react_hooks_1.renderHook)(function () { return (0, _1.usePersistState)(store); }, {
                        wrapper: function (_a) {
                            var children = _a.children;
                            return (react_1.default.createElement(PersistStateProvider_1.PersistStateProvider, { client: client }, children));
                        },
                    }), result = _a.result, waitForNextUpdate = _a.waitForNextUpdate;
                    return [4 /*yield*/, waitForNextUpdate()];
                case 1:
                    _b.sent();
                    subscriber = jest.fn();
                    store.__subscribe(subscriber);
                    (0, react_hooks_1.act)(function () {
                        var _a = result.current, setValue = _a[1];
                        setValue(12345);
                    });
                    return [4 /*yield*/, waitForNextUpdate()];
                case 2:
                    _b.sent();
                    expect(result.current[0]).toEqual(12345);
                    expect(subscriber).toHaveBeenCalledWith(12345);
                    return [2 /*return*/];
            }
        });
    }); });
});
